local BaikItemLevel = LibStub("AceAddon-3.0"):GetAddon("BaikItemLevel")
local ItemUpgradeInfo = LibStub("LibItemUpgradeInfo-1.0")
local ItemHelper = {}

-- Add Module to Addon
BaikItemLevel.ItemHelper = ItemHelper

local QUALITY_MAP = nil

local function LoadQualityMap()
    return {
        [0] = BaikItemLevel.db.profile.colorLevelPoor,
        BaikItemLevel.db.profile.colorLevelCommon,
        BaikItemLevel.db.profile.colorLevelUncommon,
        BaikItemLevel.db.profile.colorLevelRare,
        BaikItemLevel.db.profile.colorLevelEpic,
        BaikItemLevel.db.profile.colorLevelLegend,
    }
end

function ItemHelper:GetItemLevel(link)
    local hasItem = link
    local itemLevel = nil
    local itemQuality = nil
    if hasItem then
        itemLevel = ItemUpgradeInfo:GetUpgradedItemLevel(link)
        itemQuality = select(3, GetItemInfo(link))
    end

    return itemLevel, hasItem, itemQuality
end

function ItemHelper:GetQualityColor(itemLevel)
    if not QUALITY_MAP then
        QUALITY_MAP = LoadQualityMap()
    end
    local avgItemLevel = select(2, GetAverageItemLevel())
    local deltaItemLevel = itemLevel - avgItemLevel
    local itemQuality = 6

    for quality, itemLevelMax in pairs(QUALITY_MAP) do
        if deltaItemLevel < itemLevelMax then
            itemQuality = quality
            break
        end
    end

    return itemQuality
end
